diff -ruNp ejudge-2.3.18/new_server_html.c ejudge/new_server_html.c
--- ejudge-2.3.18/new_server_html.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/new_server_html.c	2011-07-11 09:02:04.084281838 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: new_server_html.c 6200 2011-03-29 19:19:28Z cher $ */
+/* $Id: new_server_html.c 6381 2011-06-25 18:52:12Z cher $ */
 
 /* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -1056,7 +1056,7 @@ privileged_page_login_page(FILE *fout, s
   struct html_armor_buffer ab = HTML_ARMOR_INITIALIZER;
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, ns_fancy_priv_header, 0, 0, 0, 0, phr->locale_id, "Login page");
+  ns_header(fout, ns_fancy_priv_header, 0, 0, 0, 0, phr->locale_id, NULL, "Login page");
   html_start_form(fout, 1, phr->self_url, "");
   fprintf(fout, "<table>\n");
   fprintf(fout, "<tr><td>%s:</td><td><input type=\"text\" size=\"32\" name=\"login\"", _("Login"));
@@ -1129,10 +1129,11 @@ html_error_status_page(FILE *fout,
   }
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, NULL,
             _("Operation completed with errors"));
   if (extra->separator_txt && *extra->separator_txt) {
-    fprintf(fout, "%s%s", ns_fancy_empty_status, extra->separator_txt);
+    fprintf(fout, "%s", ns_fancy_empty_status);
+    ns_separator(fout, extra->separator_txt, cnts);
   }
   fprintf(fout, "<font color=\"red\"><pre>%s</pre></font>\n", ARMOR(log_txt));
   fprintf(fout, "<hr>%s%s</a>\n",
@@ -4548,7 +4549,7 @@ priv_confirmation_page(FILE *fout,
   }
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s &quot;%s&quot;",
             ns_unparse_role(phr->role), phr->name_arm, phr->contest_id,
             extra->contest_arm, _("Confirm action"),
@@ -4795,7 +4796,7 @@ priv_user_detail_page(FILE *fout,
     FAIL(NEW_SRV_ERR_PERMISSION_DENIED);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s %d", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm,
             _("Details for user "), user_id);
@@ -4821,7 +4822,7 @@ priv_new_run_form_page(FILE *fout,
     FAIL(NEW_SRV_ERR_PERMISSION_DENIED);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, _("Add new run"));
   ns_new_run_form(fout, log_f, phr, cnts, extra);
@@ -4849,7 +4850,7 @@ priv_examiners_page(
   */
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, _("Add new run"));
   ns_examiners_page(fout, log_f, phr, cnts, extra);
@@ -5022,7 +5023,7 @@ priv_view_users_page(
   if (opcaps_check(phr->caps, OPCAP_GET_USER) >= 0) details_allowed = 1;
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, _("Users page"));
 
@@ -5326,7 +5327,7 @@ priv_view_priv_users_page(FILE *fout,
   qsort(users.v, users.u, sizeof(users.v[0]), priv_user_info_sort_func);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, _("Privileged users page"));
 
@@ -5575,7 +5576,7 @@ priv_view_clar(FILE *fout,
   }
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s %d", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm,
             _("Viewing clar"), clar_id);
@@ -5608,7 +5609,7 @@ priv_standings(FILE *fout,
   }
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, _("Current standings"));
   ns_write_priv_standings(cs, phr, cnts, fout, cs->accepting_mode);
@@ -5667,7 +5668,7 @@ priv_upload_runlog_csv_1(
     FAIL(NEW_SRV_ERR_PERMISSION_DENIED);  
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, "Add new runs in CSV format");
   html_start_form(fout, 2, phr->self_url, phr->hidden_vars);
@@ -5749,7 +5750,7 @@ priv_upload_runlog_csv_2(
   close_memstream(ff); ff = 0;
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, _("Adding new runs"));
 
@@ -5795,7 +5796,7 @@ priv_upload_runlog_xml_1(
     FAIL(NEW_SRV_ERR_PERMISSION_DENIED);  
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, "Merge XML runlog");
   html_start_form(fout, 2, phr->self_url, phr->hidden_vars);
@@ -5848,7 +5849,7 @@ priv_upload_runlog_xml_2(
   close_memstream(ff); ff = 0;
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, _("Merging runs"));
 
@@ -5907,7 +5908,7 @@ priv_download_runs_confirmation(
   }
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, "Download runs configuration");
 
@@ -6080,7 +6081,7 @@ priv_upsolving_configuration_1(
   }
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, "Upsolving configuration");
 
@@ -6215,7 +6216,7 @@ priv_assign_cyphers_1(
     FAIL(NEW_SRV_ERR_PERMISSION_DENIED);  
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, "Assign cyphers");
   html_start_form(fout, 1, phr->self_url, phr->hidden_vars);
@@ -6344,7 +6345,7 @@ priv_assign_cyphers_2(
   if (r < 0) FAIL(NEW_SRV_ERR_INTERNAL);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm,
             _("Assigned cyphers"));
@@ -6443,7 +6444,7 @@ priv_view_passwords(FILE *fout,
   } else {
     s = _("Registration passwords");
   }
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm, s);
 
@@ -6469,7 +6470,7 @@ priv_view_online_users(
   if (phr->role < USER_ROLE_JUDGE) FAIL(NEW_SRV_ERR_PERMISSION_DENIED);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm,
             _("Online users"));
@@ -6494,7 +6495,7 @@ priv_view_user_ips(
   if (phr->role < USER_ROLE_JUDGE) FAIL(NEW_SRV_ERR_PERMISSION_DENIED);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm,
             _("IP addresses for users"));
@@ -6519,7 +6520,7 @@ priv_view_ip_users(
   if (phr->role < USER_ROLE_JUDGE) FAIL(NEW_SRV_ERR_PERMISSION_DENIED);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm,
             _("Users for IP addresses"));
@@ -6544,7 +6545,7 @@ priv_view_exam_info(
   if (phr->role < USER_ROLE_JUDGE) FAIL(NEW_SRV_ERR_PERMISSION_DENIED);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm,
             _("Examination information"));
@@ -6569,7 +6570,7 @@ priv_priority_form(
   if (phr->role != USER_ROLE_ADMIN) FAIL(NEW_SRV_ERR_PERMISSION_DENIED);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm,
             _("Judging priorities"));
@@ -6594,7 +6595,7 @@ priv_view_testing_queue(
   if (phr->role != USER_ROLE_ADMIN) FAIL(NEW_SRV_ERR_PERMISSION_DENIED);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm,
             _("Testing queue"));
@@ -6722,7 +6723,7 @@ priv_admin_contest_settings(
   if (phr->role != USER_ROLE_ADMIN) FAIL(NEW_SRV_ERR_PERMISSION_DENIED);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm,
             _("Contest settings"));
@@ -6779,7 +6780,7 @@ priv_print_user_exam_protocol(
   if (locale_id > 0) l10n_setlocale(0);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, _("Printing user protocol"));
 
@@ -6881,7 +6882,7 @@ priv_print_users_exam_protocol(
   if (locale_id > 0) l10n_setlocale(0);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm, _("Printing user protocol"));
 
@@ -6946,7 +6947,7 @@ priv_print_problem_exam_protocol(
   if (locale_id > 0) l10n_setlocale(0);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role), phr->name_arm,
             phr->contest_id, extra->contest_arm,_("Printing problem protocol"));
 
@@ -7635,7 +7636,7 @@ priv_submit_page(
   } else {
     snprintf(bb, sizeof(bb), "%s", _("Submit a solution"));
   }
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm, bb);
 
@@ -7957,7 +7958,7 @@ priv_main_page(FILE *fout,
       need_examiners = 1;
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %d, %s]: %s", ns_unparse_role(phr->role),
             phr->name_arm, phr->contest_id, extra->contest_arm, _("Main page"));
   fprintf(fout, "<ul>\n");
@@ -9102,7 +9103,7 @@ unpriv_page_forgot_password_1(FILE *fout
   unpriv_load_html_style(phr, cnts, &extra, &cur_time);
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             _("Lost password recovery [%s]"), extra->contest_arm);
 
   // change language button
@@ -9130,7 +9131,7 @@ unpriv_page_forgot_password_1(FILE *fout
 
   //fprintf(fout, "<div class=\"l13\">\n");
   if (extra->separator_txt && *extra->separator_txt)
-    fprintf(fout, "%s", extra->separator_txt);
+    ns_separator(fout, extra->separator_txt, cnts);
 
   fprintf(fout, _("<p class=\"fixed_width\">Password recovery requires several steps. Now, please, specify the <b>login</b> and the <b>e-mail</b>, which was specified when the login was created.</p>\n<p class=\"fixed_width\">Note, that automatic password recovery is not possible for invisible, banned, locked, or privileged users!</p>\n"));
 
@@ -9219,11 +9220,11 @@ unpriv_page_forgot_password_2(FILE *fout
     close_memstream(log_f); log_f = 0;
 
     l10n_setlocale(phr->locale_id);
-    ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
-                     _("Password recovery error"));
+    ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
+              _("Password recovery error"));
     fprintf(fout, "%s", ns_fancy_empty_status);
     if (extra->separator_txt && *extra->separator_txt)
-      fprintf(fout, "%s", extra->separator_txt);
+      ns_separator(fout, extra->separator_txt, cnts);
     fprintf(fout, "<p>Password recovery is not possible because of the following error.</p>\n");
     //fprintf(fout, "%s", extra->separator_txt);
     fprintf(fout, "<font color=\"red\"><pre>%s</pre></font>\n", ARMOR(log_txt));
@@ -9233,12 +9234,12 @@ unpriv_page_forgot_password_2(FILE *fout
   }
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             _("Password recovery, stage 1 [%s, %s]"),
             ARMOR(login), extra->contest_arm);
   fprintf(fout, "%s", ns_fancy_empty_status);
   if (extra->separator_txt && *extra->separator_txt)
-    fprintf(fout, "%s", extra->separator_txt);
+    ns_separator(fout, extra->separator_txt, cnts);
 
   fprintf(fout, _("<p class=\"fixed_width\">First stage of password recovery is successful. You should receive an e-mail message with further instructions. <b>Note,</b> that you should confirm password recovery in 24 hours, or operation will be cancelled.</p>"));
 
@@ -9317,11 +9318,11 @@ unpriv_page_forgot_password_3(FILE *fout
     close_memstream(log_f); log_f = 0;
 
     l10n_setlocale(phr->locale_id);
-    ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+    ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
               _("Password recovery error"));
     fprintf(fout, "%s", ns_fancy_empty_status);
     if (extra->separator_txt && *extra->separator_txt)
-      fprintf(fout, "%s", extra->separator_txt);
+      ns_separator(fout, extra->separator_txt, cnts);
     fprintf(fout, "<p>Password recovery is not possible because of the following error.</p>\n");
     //fprintf(fout, "%s", extra->separator_txt);
     fprintf(fout, "<font color=\"red\"><pre>%s</pre></font>\n", ARMOR(log_txt));
@@ -9334,12 +9335,12 @@ unpriv_page_forgot_password_3(FILE *fout
   if (!s || !*s) s = login;
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             _("Password recovery completed [%s, %s]"),
             ARMOR(s), extra->contest_arm);
   fprintf(fout, "%s", ns_fancy_empty_status);
   if (extra->separator_txt && *extra->separator_txt)
-    fprintf(fout, "%s", extra->separator_txt);
+    ns_separator(fout, extra->separator_txt, cnts);
 
   fprintf(fout, _("<p>New password is generated.</p>"));
   fprintf(fout, "<table><tr><td class=\"menu\">%s</td><td class=\"menu\"><tt>%s</tt></td></tr>\n",
@@ -9440,7 +9441,7 @@ unprivileged_page_login_page(FILE *fout,
   }
 
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             _("User login [%s]"), extra->contest_arm);
 
 
@@ -9520,7 +9521,7 @@ unprivileged_page_login_page(FILE *fout,
 
   fprintf(fout, "</tr></table></div>\n");
   if (extra->separator_txt && *extra->separator_txt)
-    fprintf(fout, "%s", extra->separator_txt);
+    ns_separator(fout, extra->separator_txt, cnts);
 
   watched_file_update(&extra->welcome, cnts->welcome_file, cur_time);
   if (extra->welcome.text && extra->welcome.text[0])
@@ -10932,14 +10933,14 @@ unpriv_view_test(FILE *fout,
                  struct contest_extra *extra)
 {
   const serve_state_t cs = extra->serve_state;
-  const struct section_global_data *global = cs->global;
+  const struct section_problem_data *prob = 0;
   int run_id, test_num, n;
   const unsigned char *s = 0;
   struct run_entry re;
   FILE *log_f = 0;
   char *log_txt = 0;
   size_t log_len = 0;
-  int enable_rep_view;
+  int enable_rep_view = -1;
 
   // run_id, test_num
   if (unpriv_parse_run_id(fout, phr, cnts, extra, &run_id, &re) < 0)
@@ -10949,8 +10950,29 @@ unpriv_view_test(FILE *fout,
     ns_html_err_inv_param(fout, phr, 0, "cannot parse test_num");
     goto cleanup;
   }
+  if (re.prob_id <= 0 || re.prob_id > cs->max_prob || !(prob = cs->probs[re.prob_id])) {
+    ns_html_err_inv_param(fout, phr, 0, "invalid problem");
+    goto cleanup;
+  }
 
-  enable_rep_view = (cs->online_view_report > 0 || (!cs->online_view_report && global->team_enable_rep_view > 0));
+  // report view is explicitly disabled by the current contest setting
+  if (cs->online_view_report < 0) enable_rep_view = 0;
+  // report view is explicitly enabled by the current contest setting
+  //if (cs->online_view_report > 0) enable_rep_view = 1;
+  // report view is disabled by the problem configuration
+  if (enable_rep_view < 0 && prob->team_enable_rep_view <= 0) enable_rep_view = 0;
+  // report view is enabled by the problem configuration
+  if (enable_rep_view < 0 && prob->team_show_judge_report > 0) enable_rep_view = 1;
+  if (enable_rep_view < 0) {
+    int visibility = cntsprob_get_test_visibility(prob, test_num, cs->online_final_visibility);
+    if (visibility == TV_FULLIFMARKED) {
+      visibility = TV_HIDDEN;
+      if (re.is_marked) visibility = TV_FULL;
+    }
+    if (visibility == TV_FULL) enable_rep_view = 1;
+  }
+
+  if (enable_rep_view < 0) enable_rep_view = 0;
 
   log_f = open_memstream(&log_txt, &log_len);
 
@@ -10962,10 +10984,6 @@ unpriv_view_test(FILE *fout,
     ns_error(log_f, NEW_SRV_ERR_PERMISSION_DENIED);
     goto done;
   }
-  if (global->team_show_judge_report <= 0) {
-    ns_error(log_f, NEW_SRV_ERR_PERMISSION_DENIED);
-    goto done;
-  }
   if (re.user_id != phr->user_id) {
     ns_error(log_f, NEW_SRV_ERR_PERMISSION_DENIED);
     goto done;
@@ -11139,7 +11157,7 @@ unpriv_view_report(FILE *fout,
   unpriv_load_html_style(phr, cnts, 0, 0);
   l10n_setlocale(phr->locale_id);
   ns_header(fout, extra->header_txt, 0, 0, phr->script_part, phr->body_attr,
-            phr->locale_id,
+            phr->locale_id, cnts,
             "%s [%s]: %s %d",
             phr->name_arm, extra->contest_arm, _("Report for run"),
             run_id);
@@ -11186,7 +11204,7 @@ unpriv_view_report(FILE *fout,
         write_xml_team_testing_report(cs, prob, fout,
                                       prob->type != PROB_TYPE_STANDARD,
                                       re.is_marked,
-                                      rep_start, "b1");
+                                      rep_start, "b1", phr->session_id, phr->self_url, "", new_actions_vector);
       }
     }
     break;
@@ -11295,8 +11313,7 @@ unpriv_view_clar(FILE *fout,
 
   unpriv_load_html_style(phr, cnts, 0, 0);
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, extra->header_txt, 0, 0, phr->script_part, phr->body_attr,
-            phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, phr->script_part, phr->body_attr, phr->locale_id, cnts,
             "%s [%s]: %s %d",
             phr->name_arm, extra->contest_arm, _("Clarification"),
             clar_id);
@@ -11383,8 +11400,7 @@ unpriv_view_standings(FILE *fout,
   unpriv_load_html_style(phr, cnts, 0, 0);
   l10n_setlocale(phr->locale_id);
   if (start_time <= 0) {
-    ns_header(fout, extra->header_txt, 0, 0, phr->script_part, phr->body_attr,
-              phr->locale_id,
+    ns_header(fout, extra->header_txt, 0, 0, phr->script_part, phr->body_attr, phr->locale_id, cnts,
               "%s [%s]: %s",
               phr->name_arm, extra->contest_arm, _("Standings [not started]"));
     unpriv_page_header(fout, phr, cnts, extra, start_time, stop_time);
@@ -11424,8 +11440,7 @@ unpriv_view_standings(FILE *fout,
     }
   }
 
-  ns_header(fout, extra->header_txt, 0, 0, phr->script_part, phr->body_attr,
-            phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, phr->script_part, phr->body_attr, phr->locale_id, cnts,
             "%s [%s]: %s%s",
             phr->name_arm, extra->contest_arm, _("Standings"), comment);
 
@@ -11446,10 +11461,10 @@ unpriv_view_standings(FILE *fout,
     fprintf(fout, _("<p>Information is not available.</p>"));
   } else if (global->score_system == SCORE_OLYMPIAD) {
     //fprintf(fout, _("<p>Information is not available.</p>"));
-    do_write_kirov_standings(cs, cnts, fout, 0, 1, 1, 0, 0, 0, 0, 1, cur_time,
+    do_write_kirov_standings(cs, cnts, fout, 0, 1, 1, phr->user_id, 0, 0, 0, 0, 1, cur_time,
                              0, NULL, 1 /* user_mode */);
   } else if (global->score_system == SCORE_KIROV) {
-    do_write_kirov_standings(cs, cnts, fout, 0, 1, 1, 0, 0, 0, 0, 1, cur_time,
+    do_write_kirov_standings(cs, cnts, fout, 0, 1, 1, phr->user_id, 0, 0, 0, 0, 1, cur_time,
                              0, NULL, 1 /* user_mode */);
   } else if (global->score_system == SCORE_MOSCOW) {
     do_write_moscow_standings(cs, cnts, fout, 0, 1, 1, phr->user_id,
@@ -11855,7 +11870,7 @@ unpriv_page_header(FILE *fout,
 
     case '3':
       if (extra->separator_txt && *extra->separator_txt) {
-        fprintf(fout, "%s", extra->separator_txt);
+        ns_separator(fout, extra->separator_txt, cnts);
       }
       break;
 
@@ -12445,8 +12460,7 @@ unpriv_main_page(FILE *fout,
   header = gettext(hh);
   if (!header) header = _("Main page");
   unpriv_load_html_style(phr, cnts, 0, 0);
-  ns_header(fout, extra->header_txt, 0, 0, phr->script_part, phr->body_attr,
-            phr->locale_id,
+  ns_header(fout, extra->header_txt, 0, 0, phr->script_part, phr->body_attr, phr->locale_id, cnts,
             "%s [%s]: %s",
             phr->name_arm, extra->contest_arm, header);
 
@@ -13739,7 +13753,7 @@ anon_select_contest_page(FILE *fout, str
 
   // even don't know about the contest specific settings
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, ns_fancy_header, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, ns_fancy_header, 0, 0, 0, 0, phr->locale_id, NULL,
             _("Contest selection"));
 
   html_start_form(fout, 1, phr->self_url, "");
@@ -13758,7 +13772,7 @@ anon_select_contest_page(FILE *fout, str
 
   fprintf(fout, "<td class=\"menu\"><div class=\"contest_actions_item\">&nbsp;</div></td></tr></table></div>\n");
 
-  fprintf(fout, "%s", ns_fancy_separator);
+  ns_separator(fout, ns_fancy_separator, NULL);
 
   fprintf(fout, "<h2>%s</h2>\n", _("Select one of available contests"));
 
@@ -14203,6 +14217,7 @@ static const unsigned char * const symbo
   [NEW_SRV_ACTION_UPLOAD_RUNLOG_XML_2] = "UPLOAD_RUNLOG_XML_2",
   [NEW_SRV_ACTION_LOGIN] = "LOGIN",
   [NEW_SRV_ACTION_DUMP_PROBLEMS] = "DUMP_PROBLEMS",
+  [NEW_SRV_ACTION_DUMP_LANGUAGES] = "DUMP_LANGUAGES",
   [NEW_SRV_ACTION_SOFT_UPDATE_STANDINGS] = "SOFT_UPDATE_STANDINGS",
   [NEW_SRV_ACTION_HAS_TRANSIENT_RUNS] = "HAS_TRANSIENT_RUNS",
   [NEW_SRV_ACTION_DUMP_RUN_STATUS] = "DUMP_RUN_STATUS",
@@ -14210,6 +14225,10 @@ static const unsigned char * const symbo
   [NEW_SRV_ACTION_DUMP_CLAR] = "DUMP_CLAR",
   [NEW_SRV_ACTION_GET_CONTEST_NAME] = "GET_CONTEST_NAME",
   [NEW_SRV_ACTION_GET_CONTEST_TYPE] = "GET_CONTEST_TYPE",
+  [NEW_SRV_ACTION_GET_CONTEST_STATUS] = "GET_CONTEST_STATUS",
+  [NEW_SRV_ACTION_GET_CONTEST_SCHED] = "GET_CONTEST_SCHED",
+  [NEW_SRV_ACTION_GET_CONTEST_DURATION] = "GET_CONTEST_DURATION",
+  [NEW_SRV_ACTION_GET_CONTEST_DURATION] = "GET_CONTEST_DESCRIPTION",
   [NEW_SRV_ACTION_DUMP_MASTER_RUNS] = "DUMP_MASTER_RUNS",
   [NEW_SRV_ACTION_DUMP_REPORT] = "DUMP_REPORT",
   [NEW_SRV_ACTION_FULL_UPLOAD_RUNLOG_XML] = "FULL_UPLOAD_RUNLOG_XML",
diff -ruNp ejudge-2.3.18/NEWS.RUS ejudge/NEWS.RUS
--- ejudge-2.3.18/NEWS.RUS	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/NEWS.RUS	2011-07-11 09:02:04.263278546 +0400
@@ -1,5 +1,93 @@
 -*- mode: text; mode: auto-fill; coding: utf-8 -*-
-$Id: NEWS.RUS 6245 2011-04-10 05:24:07Z cher $
+$Id: NEWS.RUS 6397 2011-07-06 05:01:19Z cher $
+
+Версия 2.3.19 (r6397) (20110706)
+================================
+В исходные файлы системы добавлены файлы для пробного турнира.
+Файлы находятся в каталоге contest-1. Файлы пробного турнира
+используют новую раскладку по каталогам. В пробном турнире по
+умолчанию доступ к CGI-программам открыт для всех IP-адресов.
+
+При выполнении настроечного скрипта, сгенерированного программой
+ejudge-setup, выводится предупреждение о том, что все существовавшие
+настройки будут уничтожены.
+
+При сборке системы автоматически генерируется настроечный скрипт
+ejudge-install.sh со значениями по умолчанию. Ранее необходимо
+было запускать ejudge-setup. При необходимости изменить
+параметры по умолчанию все равно может использоваться
+ejudge-setup.
+
+В конфигурационный файл турнира contest.xml добавлены два новых
+элемента <logo_url> и <css_url>, которые позволяют
+специфицировать URL для логотипа данного турнира и URL для
+стилевого файла данного турнира.
+
+Везде, где требуется вводить e-mail, он проверяется на
+соответствие правилам формирования e-mail. 
+
+Добавлена поддержка GNU Haskell (ghc). Данный язык пока помечен
+как небезопасный. Спасибо vrandik.
+
+Добавлена поддержка архивов программ и утилит сборки, таких как
+make.
+
+ej-compile
+----------
+Лог-файл для программы переименован в ej-compile.log. Он
+по-прежнему находится в каталоге CONTESTS_HOME_DIR/compile/var.
+
+Вывод программы проверки стиля на стандартный поток вывода сохраняется
+для последующего показа.
+
+ej-contests
+-----------
+Лог-файл для программы переименован в ej-contests.log.
+
+Текст, выведенный на стандартный вывод программой проверки стиля,
+отображается при просмотре исходного кода посылки привилегированным
+пользователем.
+
+ejudge-contests-cmd
+-------------------
+Добавлены команды 'dump-languages', 'get-contest-status',
+'get-contest-sched', 'get-contest-duration',
+'get-contest-description' на основе патча от germanilyin.
+
+ej-jobs
+-------
+Лог-файл для программы переименован в ej-jobs.log.
+
+ej-super-server
+---------------
+Лог-файл для программы переименован в ej-super-server.log.
+
+Добавлена возможность редактирования базы пользователей через
+веб-интерфейс. Консольная программа ejudge-edit-users более
+поддерживаться не будет.
+
+В таблицу турниров добавлены прямые ссылки на редактирование
+пользователей и редактирование настроек турнира.
+
+ej-users
+--------
+Лог-файл для программы переименован в ej-users.log.
+
+style_archive
+-------------
+Добавлена поддержка для архивов для сборки программ с помощью
+утилит сборки таких, как make. Поддерживаются следующие новые
+переменные окружения и параметры командной строки:
+EJ_MAKE_MODE (-m)	включить режим проверки архива для
+			сборки. По умолчанию включен режим
+                        проверки архива тестов.
+EJ_PROGRAM_DIR (-p)	имя каталога с файлами для сборки,
+                        который должен находится в
+                        архиве. Значение по умолчанию -
+                        solution.
+EJ_SCRIPT_NAME (-s)     название скрипта для сборки, который
+			должен находиться в архиве. Значение по
+                        умолчанию - Makefile.
 
 Версия 2.3.18 (r6245) (20110410)
 ================================
